# -*- coding: utf-8 -*-

'''
date: 07.01.2010
description: test class "collection" to test our new idea for saving all tasks
TODO: needs to be refactored - especially def insert_object()
'''

import gtk
import pickle
import os
from task import Task

class Collection:
    """ The root and the non-leaf nodes of the ExStore._data.
    The leafs are of type Task.
    """
    _data = None  # TODO transfer from here to Display.treestore and back.
                  # Transfer is presently done via pickle -- REPLACE this?!?
    _title = None
    _description = None
    _pic = None

    def __init__(self, title, descript, icon, data):
        self._title = title
        self._description = descript
        self._pic = icon
        self._data = data

    def get_data(self):
        return self._data

    def set_data(self, data):
        self._data = data

    def get_title(self):
        return self._title

    def set_title(self, title):
        self._title = title

    def get_description(self):
        return self._description

    def set_description(self, description):
        self._description = description

    ''' keep for need, TODO icon reformatting icon to string
    def getPic(self):
        return self._pic

    def setPic(self, pic):
        self._pic = pic
    '''

    def insert_object(self, obj, pos, pos_spec):
        """ Handles the insertion of dropped objects in list and pickle. """
        root = self.get_data_from_pickle()
        list = root.get_data()
        #attach at the end - if drop occured in some area beneath the widget
        if (pos == None):
            list.append(obj)

        #if object was edited or used
        elif(pos_spec == "edit"):
            for i in range(len(pos)):
                try:
                    if isinstance(list[pos[i]], Collection):
                        if (i == (len(pos)-1)):
                            list.insert(pos[i], obj)
                        else:
                            list = list[pos[i]].get_data()
                    else:
                        list.insert(pos[i], obj)
                except IndexError:
                    list.append(obj)

        #for drag and drop
        else:
            for i in range(len(pos)):
                try:
                    if isinstance(list[pos[i]], Collection):
                        if ((pos_spec == gtk.TREE_VIEW_DROP_BEFORE) and
                            (i == (len(pos)-1))):
                            list.insert(pos[i], obj)
                        elif((pos_spec == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE) and
                            (i == (len(pos)-1))):
                            list = list[pos[i]].get_data()
                            list.append(obj)
                        elif((pos_spec == gtk.TREE_VIEW_DROP_INTO_OR_AFTER) and
                            (i == (len(pos)-1))):
                            list = list[pos[i]].get_data()
                            list.append(obj)
                        elif((pos_spec == gtk.TREE_VIEW_DROP_AFTER) and
                            (i == (len(pos)-1))):
                            list.insert(pos[i]+1, obj)
                        else:
                            list = list[pos[i]].get_data()
                    else:
                        if ((pos_spec == gtk.TREE_VIEW_DROP_BEFORE or
                            pos_spec == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE) and
                            (i == (len(pos)-1))):
                            list.append(obj)
                        elif((pos_spec == gtk.TREE_VIEW_DROP_AFTER) or
                            (pos_spec == gtk.TREE_VIEW_DROP_INTO_OR_AFTER) and
                            (i == (len(pos)-1))):
                            list.insert(pos[i]+1, obj)
                        else:
                            list.append(obj)
                except IndexError:
                    list.append(obj) #exception to handle IndexError

        self.set_data_in_pickle(root)

    def get_object(self, pos):
        """ Deletes and returns an object from list """
        root = self.get_data_from_pickle()
        list = root.get_data()
        #find object and return it to insert it in collection
        for i in range(len(pos)):
            if isinstance(list[pos[i]], Collection):
                obj = pos[i]
                if i < (len(pos)-1):
                    list = list[pos[i]].get_data()
            else:
                obj = pos[i]
        #delete object in list but return it
        obj = list.pop(obj)
        self.set_data_in_pickle(root)
        return obj

    def get_object_by_tupel(self, tupel):
        """ get n-th element given with a n-tupel """
        el = self
        for n in tupel:
            el = el.get_data()[n]
        return el

    def get_data_from_pickle(self):
        """ Returns data from pickle file """
        path = os.path.join(os.getcwd(), "data/Collection.data")
        f = open(path, "rb")
        root = pickle.load(f)
        f.close()
        return root

    def set_data_in_pickle(self, root):
        """ Sets data in pickle file """
        path = os.path.join(os.getcwd(), "data/Collection.data")
        f = open(path, "wb")
        pickle.dump(root, f)
        f.close()
        
    def get_selected_object(self, sel):
        print("selection: " + len(sel))
        return
