# -*- coding: utf-8 -*-

class Learner:
    """ All functionality within the learners rights. """

    def __init__(self, display, coach):
        self._dis = display
        self._coach = coach
        self._ex = None
        self._curr_in = None

    def run(self):
        # Initializing the learners tree view: loading exercises
        self._coach.request_exercise()

    def start_calcs(self, exercise):
        self._ex = exercise
        _calc = self._ex.get_next_calc()
        #print('learner.start calcs: _calc = ', _calc)
        #print('learner.start calcs: carry = ', self._ex._sett['carry'])
        _lines, self._input = exercise.format(_calc)
        #print('start calcs: _lines = ', _lines)
        #print('start calcs: --------------------------------')
        #print('start calcs: self._input = ', self._input)
        #print('start calcs: ================================')
        self._dis.display_calc(_lines)
        self._curr_in = self._input.pop()
        self._dis.create_entryline(self._curr_in)

    def digit_done(self):
        (lino, pos, dig, proterr, protok, li) = self._curr_in
        self._dis.create_entryline((lino, -1, dig, proterr, protok, li))
        try: # _input.pop()
            self._curr_in = self._input.pop()
            self._dis.create_entryline(self._curr_in)
        except IndexError: # start new calc
            self._dis.show_progress()
            try: # get_next_calc
                _calc = self._ex.get_next_calc()
                #print('in learner.notify: calc=', _calc)
                _lines, self._input = self._ex.format(_calc)
                self._dis.display_calc(_lines)
                self._curr_in = self._input.pop() #need _curr_in in notify
                self._dis.create_entryline(self._curr_in)
                # create_entryline sets the callback from gtk to Display
            except IndexError:
                self._dis.finish_calc()

