# -*- coding: utf-8 -*-

'''
author: (c) Bernhard Ruttinger 2009
date: 02.12.2009
description: test class "task" to test our new idea for saving all tasks
'''

class Task:
    """ The leaf-type of the ExStore._data. The root and the non-leaf nodes
    are of type Collection.
    """
    _sett = None
    _eval = None

    def get_data(self):
        return self

    def __init__(self, sett, eval):
        self._sett = sett
        self._eval = eval

    def get_title(self):
        return self._sett['title']

    def set_title(self, title):
        self._sett['title'] = title

    def get_description(self):
        return self._sett['descript']

    def set_description(self, description):
       self._sett['descript'] = description

    def get_settings(self):
        return self._sett

    def set_settings(self, sett):
        self._sett = sett

    def get_eval(self):
        return self._eval

    def set_eval(self, eval):
        self._eval = eval

    def get_object_name(self):
        return self._sett['topic']



